"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.choiceOf = choiceOf;
var _encoder = require("../encoder/encoder");
var _elements = require("../utils/elements");
function choiceOf(...alternatives) {
  if (alternatives.length === 0) {
    throw new Error('`choiceOf` should receive at least one alternative');
  }
  return {
    type: 'choiceOf',
    alternatives: alternatives.map(c => (0, _elements.ensureArray)(c)),
    encode: encodeChoiceOf
  };
}
function encodeChoiceOf() {
  const encodedAlternatives = this.alternatives.map(c => (0, _encoder.encodeSequence)(c));
  if (encodedAlternatives.length === 1) {
    return encodedAlternatives[0];
  }
  return {
    precedence: 'disjunction',
    pattern: encodedAlternatives.map(n => n.pattern).join('|')
  };
}
//# sourceMappingURL=choice-of.js.map