"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.oneOrMore = oneOrMore;
exports.optional = optional;
exports.zeroOrMore = zeroOrMore;
var _encoder = require("../encoder/encoder");
var _elements = require("../utils/elements");
function zeroOrMore(sequence, options) {
  return {
    type: 'zeroOrMore',
    children: (0, _elements.ensureArray)(sequence),
    options,
    encode: encodeZeroOrMore
  };
}
function oneOrMore(sequence, options) {
  return {
    type: 'oneOrMore',
    children: (0, _elements.ensureArray)(sequence),
    options,
    encode: encodeOneOrMore
  };
}
function optional(sequence, options) {
  return {
    type: 'optional',
    children: (0, _elements.ensureArray)(sequence),
    options,
    encode: encodeOptional
  };
}
function encodeZeroOrMore() {
  var _this$options;
  return {
    precedence: 'sequence',
    pattern: `${(0, _encoder.encodeAtom)(this.children).pattern}*${((_this$options = this.options) === null || _this$options === void 0 ? void 0 : _this$options.greedy) === false ? '?' : ''}`
  };
}
function encodeOneOrMore() {
  var _this$options2;
  return {
    precedence: 'sequence',
    pattern: `${(0, _encoder.encodeAtom)(this.children).pattern}+${((_this$options2 = this.options) === null || _this$options2 === void 0 ? void 0 : _this$options2.greedy) === false ? '?' : ''}`
  };
}
function encodeOptional() {
  var _this$options3;
  return {
    precedence: 'sequence',
    pattern: `${(0, _encoder.encodeAtom)(this.children).pattern}?${((_this$options3 = this.options) === null || _this$options3 === void 0 ? void 0 : _this$options3.greedy) === false ? '?' : ''}`
  };
}
//# sourceMappingURL=quantifiers.js.map