"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.repeat = repeat;
var _encoder = require("../encoder/encoder");
var _elements = require("../utils/elements");
function repeat(sequence, options) {
  const children = (0, _elements.ensureArray)(sequence);
  if (children.length === 0) {
    throw new Error('`repeat` should receive at least one element');
  }
  return {
    type: 'repeat',
    children,
    options,
    encode: encodeRepeat
  };
}
function encodeRepeat() {
  var _this$options;
  const atomicNodes = (0, _encoder.encodeAtom)(this.children);
  if (typeof this.options === 'number') {
    return {
      precedence: 'sequence',
      pattern: `${atomicNodes.pattern}{${this.options}}`
    };
  }
  return {
    precedence: 'sequence',
    pattern: `${atomicNodes.pattern}{${this.options.min},${((_this$options = this.options) === null || _this$options === void 0 ? void 0 : _this$options.max) ?? ''}}${this.options.greedy === false ? '?' : ''}`
  };
}
//# sourceMappingURL=repeat.js.map