import { encodeAtom } from '../encoder/encoder';
import { ensureArray } from '../utils/elements';
export function zeroOrMore(sequence, options) {
  return {
    type: 'zeroOrMore',
    children: ensureArray(sequence),
    options,
    encode: encodeZeroOrMore
  };
}
export function oneOrMore(sequence, options) {
  return {
    type: 'oneOrMore',
    children: ensureArray(sequence),
    options,
    encode: encodeOneOrMore
  };
}
export function optional(sequence, options) {
  return {
    type: 'optional',
    children: ensureArray(sequence),
    options,
    encode: encodeOptional
  };
}
function encodeZeroOrMore() {
  var _this$options;
  return {
    precedence: 'sequence',
    pattern: `${encodeAtom(this.children).pattern}*${((_this$options = this.options) === null || _this$options === void 0 ? void 0 : _this$options.greedy) === false ? '?' : ''}`
  };
}
function encodeOneOrMore() {
  var _this$options2;
  return {
    precedence: 'sequence',
    pattern: `${encodeAtom(this.children).pattern}+${((_this$options2 = this.options) === null || _this$options2 === void 0 ? void 0 : _this$options2.greedy) === false ? '?' : ''}`
  };
}
function encodeOptional() {
  var _this$options3;
  return {
    precedence: 'sequence',
    pattern: `${encodeAtom(this.children).pattern}?${((_this$options3 = this.options) === null || _this$options3 === void 0 ? void 0 : _this$options3.greedy) === false ? '?' : ''}`
  };
}
//# sourceMappingURL=quantifiers.js.map