import type { EncodeResult } from '../encoder/types';
import type { RegexConstruct } from '../types';
export interface CharacterClass extends RegexConstruct {
    type: 'characterClass';
    escape?: string;
    chars: string[];
    ranges: CharacterRange[];
    isNegated: boolean;
    encode: () => EncodeResult;
}
/**
 * Character range from start to end (inclusive).
 */
export interface CharacterRange {
    start: string;
    end: string;
}
export declare const any: CharacterClass;
export declare const digit: CharacterClass;
export declare const nonDigit: CharacterClass;
export declare const word: CharacterClass;
export declare const nonWord: CharacterClass;
export declare const whitespace: CharacterClass;
export declare const nonWhitespace: CharacterClass;
/**
 * @deprecated Renamed to `nonDigit`.
 */
export declare const notDigit: CharacterClass;
/**
 * @deprecated Renamed to `nonWord`.
 */
export declare const notWord: CharacterClass;
/**
 * @deprecated Renamed to `nonWhitespace`.
 */
export declare const notWhitespace: CharacterClass;
export declare function charClass(...elements: CharacterClass[]): CharacterClass;
export declare function charRange(start: string, end: string): CharacterClass;
export declare function anyOf(characters: string): CharacterClass;
export declare function negated(element: CharacterClass): CharacterClass;
/**
 * @deprecated Renamed to `negated`.
 */
export declare const inverted: typeof negated;
//# sourceMappingURL=character-class.d.ts.map