import type { RegexConstruct, RegexElement, RegexSequence } from '../types';
export interface QuantifierOptions {
    greedy?: boolean;
}
export interface ZeroOrMore extends RegexConstruct {
    type: 'zeroOrMore';
    children: RegexElement[];
    options?: QuantifierOptions;
}
export interface OneOrMore extends RegexConstruct {
    type: 'oneOrMore';
    children: RegexElement[];
    options?: QuantifierOptions;
}
export interface Optional extends RegexConstruct {
    type: 'optional';
    children: RegexElement[];
    options?: QuantifierOptions;
}
export declare function zeroOrMore(sequence: RegexSequence, options?: QuantifierOptions): ZeroOrMore;
export declare function oneOrMore(sequence: RegexSequence, options?: QuantifierOptions): OneOrMore;
export declare function optional(sequence: RegexSequence, options?: QuantifierOptions): Optional;
//# sourceMappingURL=quantifiers.d.ts.map